// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <iostream>

#include <anna/core/util/CommandLine.hpp>
#include <anna/core/tracing/Logger.hpp>
#include <anna/core/tracing/TraceWriter.hpp>

#include <anna/http/functions.hpp>

#include "Application.hpp"

using namespace std;
using namespace anna;
using namespace test;

/**
 * Esta es una implementacin de un Gateway que recibe peticiones de operaciones aritmticas
 * desde un cliente que enva peticiones HTTP y un servidor que atiende peticiones en el protocolo
 * anna::comm::SureTransport
 *
 * Usa la clase anna::timex::Context para gestionar automticamente toda la creacin y liberacin
 * de las transaciones usadas por la aplicacin para temporizar las peticiones-respuestas.
 */
int main (int argc, const char** argv)
{
   CommandLine& commandLine (CommandLine::instantiate ());
   http4comm::Application app;

   http::functions::initialize ();

   try {
      commandLine.initialize (argv, argc);
      commandLine.verify ();

      Logger::setLevel (Logger::Debug); 
      Logger::initialize ("http4comm", new anna::TraceWriter ("file.trace", 4048000));
 
      app.start ();
   }
   catch (Exception& ex) {
      cout << ex.asString () << endl;
   }
   
   return 0;
}

