// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_comm_Buffer_hpp
#define anna_comm_Buffer_hpp

#include <anna/core/DataBlock.hpp>

namespace anna {

namespace comm {

/**
   Clase para mantener en memoria lo buffer intermedios usados para enviar y/o recibir
   mensajes,
*/
class Buffer : public DataBlock {
public:
  /**
     Constructor.
  */
  Buffer() : DataBlock(false) {;}

  /**
     Establece la direccion de memoria asociada a esta memoria intermedia.
     \param buffer Direccion de memoria asociada a esta instancia.
     \param size Numero de bytes asociados a esta instancia.
  */
  void setup(const char* buffer, const int size) throw() {
    setBuffer(buffer);
    setSize(size);
  }

  /**
     Establece la longitud de la memoria asociada a esta instancia.
     \param size Numero de bytes asociados a esta instancia.
  */
  void resize(const int size) throw() { setSize(size); }
};

}
}

#endif
