// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_comm_internal_RemoteConnection_hpp
#define anna_comm_internal_RemoteConnection_hpp

namespace anna {

namespace xml {
class Node;
}

namespace comm {

class Server;
class ClientSocket;

class RemoteConnection  {
public:
  Server* getServer() throw() { return a_server; }

  /**
     Conversor de invocacion.
     \return La instancia del socket asociado a esta instancia. Si no hay socket asociado lanzara una excepcion.
  */
  ClientSocket* getClientSocket() throw() { return a_clientSocket; }

  std::string asString() const throw();
  xml::Node* asXML(xml::Node* parent) const throw(RuntimeException);
  static const char* className() throw() { return "anna::comm::RemoteConnection"; }

private:
  Server* a_server;
  ClientSocket* a_clientSocket;

  RemoteConnection(Server* server, ClientSocket* clientSocket) :
    a_server(server),
    a_clientSocket(clientSocket)
  {;}

  friend class Server;
};

}
}

#endif

