// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#ifndef anna_dbms_dbms_hpp
#define anna_dbms_dbms_hpp

namespace anna {
/**
Define de forma generica el protocolo de acceso a los datos guardados en un DBMS.

El ejecutable debera enlazarse con las librerias:
   \li anna.core.a
   \li anna.xml.a
   \li anna.app.a
   \li anna.comm.a
   \li anna.dbms.a

El <b>Packet Header</b> es anna.dbms.h
*/
namespace dbms {
}
}

#include <anna/dbms/Connection.hpp>
#include <anna/dbms/Data.hpp>
#include <anna/dbms/Database.hpp>
#include <anna/dbms/DatabaseException.hpp>
#include <anna/dbms/Delivery.hpp>
#include <anna/dbms/FailRecoveryHandler.hpp>
#include <anna/dbms/Integer.hpp>
#include <anna/dbms/LongBlock.hpp>
#include <anna/dbms/OutputBind.hpp>
#include <anna/dbms/ResultCode.hpp>
#include <anna/dbms/ShortBlock.hpp>
#include <anna/dbms/Statement.hpp>
#include <anna/dbms/StatementTranslator.hpp>
#include <anna/dbms/Sentence.hpp>
#include <anna/dbms/String.hpp>
#include <anna/dbms/Float.hpp>
#include <anna/dbms/Date.hpp>
#include <anna/dbms/TimeStamp.hpp>

using namespace anna::dbms;

#endif

