// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <stdio.h>

#include <anna/core/RuntimeException.hpp>
#include <anna/core/tracing/Logger.hpp>

using namespace anna;

Exception::Exception(const char* text, const char* name, const char* fromFile, const int fromLine) :
  m_errorCode(-1) {
  m_text = text;
  m_name = name;
  m_fromFile = fromFile;
  m_fromLine = fromLine;
}

Exception::Exception(const char* text, const char* fromFile, const int fromLine)  :
  m_errorCode(-1) {
  m_text = text;
  m_name = "Exception";
  m_fromFile = fromFile;
  m_fromLine = fromLine;
}

Exception::Exception(const Exception& other) {
  m_text = other.m_text;
  m_name = other.m_name;
  m_fromFile = other.m_fromFile;
  m_fromLine = other.m_fromLine;
  m_errorCode = other.m_errorCode;
}

//-----------------------------------------------------------------------
// Operador copia
//-----------------------------------------------------------------------
Exception& Exception::operator = (const Exception & other)
throw() {
  if(this != &other) {
    m_name = other.m_name;
    m_text = other.m_text;
    m_fromFile = other.m_fromFile;
    m_fromLine = other.m_fromLine;
    m_errorCode = other.m_errorCode;
  }

  return *this;
}

std::string Exception::asString() const
throw() {
  std::string result;
  char n [32];
  sprintf(n, " (%d) ] ", m_fromLine);
  result = "[ ";
  result += m_fromFile;
  result += n;
  result += m_name;
  result += ": ";
  result += m_text;
  return result;
}

void Exception::trace() const
throw() {
  Logger::write(Logger::Error, m_name.c_str(), m_text.c_str(), m_fromFile.c_str(), m_fromLine);       // JEDS 24/09/2003
}
