// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <anna/core/tracing/Logger.hpp>
#include <anna/core/oam/Counter.hpp>
#include <anna/core/oam/CounterScope.hpp>
#include <anna/core/util/defines.hpp>

using namespace std;
using namespace anna;


#define TEST_COUNTER_TAG   "__CNT__"


oam::Counter::Counter(oam::CounterScope& scope, const int id, const char* name) :
  a_scope(scope),
  a_id(id),
  a_value(0),
  a_accValue(0) {
  a_name = scope.getName();
  a_name += "::";
  a_name += name;
}

int oam::Counter::getReference() const
throw() {
  return (a_scope.getId() * CounterScope::MaxCounter) + a_id;
}

void oam::Counter::debug() const
throw() {
  Logger::write(Logger::Information, functions::asString("%s| Counter%08d | %u | %s", TEST_COUNTER_TAG, getReference(), a_value, a_name.c_str()), ANNA_FILE_LOCATION);
}

string oam::Counter::asString() const
throw() {
  string result("oam::Counter { Id: ");
  result += functions::asString("%08d", getReference());
  result += " | Name: ";
  result += a_name;
  result += " | Value: ";
  result += functions::asString(a_value);
  result += " | Acc-Value: ";
  result += functions::asString(a_accValue);
  return result += " }";
}

