// ANNA - Anna is Not Nothingness Anymore                                                         //
//                                                                                                //
// (c) Copyright 2005-2015 Eduardo Ramos Testillano & Francisco Ruiz Rayo                         //
//                                                                                                //
// See project site at http://redmine.teslayout.com/projects/anna-suite                           //
// See accompanying file LICENSE or copy at http://www.teslayout.com/projects/public/anna.LICENSE //


#include <anna/http/parser/WaitEndOfHeader.hpp>

#include <anna/http/Transport.hpp>
#include <anna/http/functions.hpp>
#include <anna/http/internal/defines.hpp>

using namespace std;
using namespace anna;

//----------------------------------------------------------------------------------------------------
// Recordar que slo se llega a este estado en caso de haber encontrado el 'Content-Length'.
//----------------------------------------------------------------------------------------------------
int http::parser::WaitEndOfHeader::processLine(http::Transport& transport, const DataBlock& dataBlock, const http::Token& line) const
throw(RuntimeException) {
  /*
   * Cuando en cuenta la ltima lnea del mensaje calcula el tamao total del mensaje.
   * El Content-Length slo informa sobre la longitud del bloque de datos, pero
   * pero no tiene en cuenta lo que pueden ocupar las cabeceras y dems etiquetas.
   */
  if(line.getSize() == 0) {
    const int bodyOffset = line.calculeOffset(dataBlock) + sizeEndOfLine;
    transport.setBodyOffset(bodyOffset);
    setState(transport, ClassType::WaitMessage);
    return bodyOffset + transport.getContentLength();
  }

  return ReadHeader::processLine(transport, dataBlock, line);
}

